using GrapeCity.ActiveReports.Document.Section;
using System;
using System.Drawing;

namespace TextWrapping_v16
{
    /// <summary>
    /// Summary description for SectionReport1.
    /// </summary>
    public partial class SectionReport1 : GrapeCity.ActiveReports.SectionReport
    {

        public SectionReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.ReportEnd += SectionReport1_ReportEnd;
        }

        private void SectionReport1_ReportEnd(object sender, EventArgs e)
        {
            float pvWidth = 7.8f;
            string pvData = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";
            var page = Document.Pages[0];
            var font = new Font("Arial", 12, FontStyle.Bold);
            page.Font = font;
            SizeF sz = Document.Pages[0].MeasureParagraphHeight(pvData, pvWidth);
            float lineHeight = sz.Height;
            float yPos = 0;
            string[] words = pvData.Split(' ');
            string line = "";
            foreach (string word in words)
            {
                string testLine = string.IsNullOrEmpty(line) ? word : line + " " + word;
                SizeF size = page.MeasureText(testLine, font);
                if (size.Width <= pvWidth)
                {
                    if (!string.IsNullOrEmpty(line))
                    {
                        line += " ";
                    }
                    line += word;
                }
                else
                {
                    page.DrawText(line, 0.1f, yPos, pvWidth, lineHeight);
                    yPos += lineHeight;
                    line = word;
                }
            }
            if (!string.IsNullOrEmpty(line))
            {
                page.DrawText(line, 0.1f, yPos, pvWidth, lineHeight);
            }
        }
    }
}